<template>
	<div class="p-3">
		<div class="base_block p-3 mb-3">
			<form class="dash_ftr" @submit.prevent="getData()">

				<div class="d-flex align-items-center py-2 mr-4 position-relative">
					<label style="width: 140px;" class="col-form-label">{{$store.state.locale.beginDate}}:</label>
					<datepicker
							v-model="fromDate"
							:config="options">
					</datepicker>
				</div>

				<div class="d-flex align-items-center py-2 mr-4 position-relative">
					<label style="width: 180px;" class="col-form-label">{{$store.state.locale.endDate}}:</label>
					<datepicker
							v-model="toDate"
							:config="options">
					</datepicker>
				</div>


				<button type="submit" class="btn call_save_btn dash_ftr_btn">{{ $store.state.locale.filter }}
				</button>
			</form>
		</div>

		<div class="base_block">
			<div class="cplt">
				<div class="cplt_cnt">
					<div class="cplt_table">
						<div class="cplt_table_bd">
							<div class="table-responsive settings_content_tb">
								<table class="table table-striped table-hover">
									<thead>
									<tr>
										<th scope="col">№</th>
										<th scope="col">{{$store.state.locale.callBegin}}</th>
										<th scope="col">{{$store.state.locale.answerTime}}</th>
										<th scope="col">{{$store.state.locale.operId}}</th>
										<th scope="col">{{$store.state.locale.asnwerNumber}}</th>
										<th scope="col">{{$store.state.locale.callDuration}}</th>
										<th scope="col">{{$store.state.locale.callState}}</th>
										<th scope="col">{{$store.state.locale.callEnd}}</th>
									</tr>
									</thead>

									<tbody>
										<tr v-for="(result, index) in resultList">
											<td>{{(index + 1) + (page * 20)}}</td>
											<td>{{result.startStamp | filterDate}}</td>
											<td>{{result.answerStamp | filterDate}}</td>
											<td>{{result.callerIdNumber}}</td>
											<td>{{result.destinationNumber}}</td>
											<td>{{result.duration}}</td>
											<td>{{result.rejectedCause}}</td>
											<td>{{result.endStamp | filterDate}}</td>
										</tr>
									</tbody>
								</table>
							</div>
						</div>

						<div style="margin-top: 16px;" class="call_message_ft d-flex justify-content-center" v-if="(pageCount > 1)">
							<paginate
									:page-count="pageCount"
									:page-range="3"
									:margin-pages="1"
									:click-handler="getData"
									container-class="pagination base_pagination"
									page-class="page-item"
									prev-class="page-item ctrl"
									next-class="page-item ctrl"
									page-link-class="page-link"
									prev-link-class="page-link"
									next-link-class="page-link"
									prev-text="<i class='mdi mdi-chevron-left'></i>"
									next-text="<i class='mdi mdi-chevron-right'></i>"
							>
							</paginate>
						</div>

					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
	import Paginate from "vuejs-paginate";
	import Datepicker from "vue-bootstrap-datetimepicker";
	import 'pc-bootstrap4-datetimepicker/build/css/bootstrap-datetimepicker.css';

	export default {
		name: "index",
		components: {Datepicker, Paginate},
		data() {
			return {
				page: 0,
				forPageCount: 0,
				interval: 0,
				resultList: [],
				fromDate: '',
				toDate: '',
				options: {
					format: 'YYYY-MM-DD',
					useCurrent: false,
					showClear: true,
					showClose: true,
					locale: 'ru',
					icons: {
						time: 'mdi mdi-clock-outline',
						date: 'mdi mdi-calendar',
						up: 'mdi mdi-arrow-up',
						down: 'mdi mdi-arrow-down',
						previous: 'mdi mdi-arrow-left',
						next: 'mdi mdi-arrow-right',
						today: 'mdi mdi-calendar-today',
						clear: 'mdi mdi-delete-outline',
						close: 'mdi mdi-alpha-x-circle-outline'
					}
				}
			}
		},
		created() {
			this.getData();
			this.interval = setInterval(
				this.getData, 5000
			)
		},
		beforeDestroy(){
			clearInterval(this.interval);
		},
		methods: {

			getData(page = 0) {
				if (page > 0) {
					page = page - 1;
				} else {
					page = this.page
				}

				let from, to;
				if (this.fromDate || this.toDate) {
					from = this.fromDate;
					to = this.toDate;
				} else {
					let newDate = moment(new Date()).format('YYYY-MM-DD')
					from = newDate;
					this.fromDate = newDate;
					to = newDate;
					this.toDate = newDate;
				}

				// let from = moment(newDate).subtract(7,'d').format('YYYY-MM-DD')
				// let to = moment(newDate).format('YYYY-MM-DD')

				axios.post('Cdr/GetOutboundCalls', {
					startTime: from,
					endTime: to,
					page
				})
					.then(response => {
						if (response.data.success === true) {
							this.forPageCount = response.data.totalPages
							this.resultList = response.data.result
							this.page = page
						}
					})
					.catch(error => {
						console.log(error.message)
					});
			}
		},
		computed: {
			pageCount() {
				return Math.ceil(this.forPageCount / 20);
			}
		},
		filters: {
			filterDate: function (val) {
				if(val) {
					return moment(val).format('HH:mm:ss') + ' ' + moment(val).format('YYYY-MM-DD')
				}
				return ''

			}
		}
	}
</script>

<style></style>